Package com.sas.lsaf.core.type

## Enum Type.Capability

- java.lang.Object
- - java.lang.Enum<Type.Capability>
  - - com.sas.lsaf.core.type.Type.Capability

- All Implemented Interfaces:
    `java.io.Serializable`, `java.lang.Comparable<Type.Capability>`
  Enclosing class:
    Type

      public static enum Type.Capability
      extends java.lang.Enum<Type.Capability>

  This enumeration defines the capabilities that are available by each type. Some of the capabilities are defined by the system (such as folder types always have the `FILES` capability). Context capabilities are defined by customers when their custom configurable hierarchy is configured.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant | Description
    --- | ---
    `FILES` | This capability enables a context (and folder) type to enable folders and files to be created within the context.
    `MEMBERSHIP` | This capability enables a context type to maintain a membership list.
    `STATE` | This capability enables a context type to maintain a `RepositoryItem.State`.
    `STUDY` | This capability enables a context type to maintain study and standard information.
    `TOP` | This capability enables a context type to be created at the top of the repository hierarchy.
    `WORKFLOW` | This capability enables a context type to enlist in workflow-related definitions and tasks.

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static Type.Capability` | `valueOf​(java.lang.String name)` | Returns the enum constant of this type with the specified name.
    `static Type.Capability[]` | `values()` | Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### TOP

          public static final Type.Capability TOP

      This capability enables a context type to be created at the top of the repository hierarchy.
      See Also:
        `RepositoryService.getTopLevelContexts()`

    - #### MEMBERSHIP

          public static final Type.Capability MEMBERSHIP

      This capability enables a context type to maintain a membership list. It also allows groups and roles to be defined and role to be assigned.
      See Also:
        `MembershipService`, `GroupService`, `RoleService`

    - #### WORKFLOW

          public static final Type.Capability WORKFLOW

      This capability enables a context type to enlist in workflow-related definitions and tasks. This capability requires the `MEMBERSHIP` capability.

    - #### STATE

          public static final Type.Capability STATE

      This capability enables a context type to maintain a `RepositoryItem.State`.

    - #### STUDY

          public static final Type.Capability STUDY

      This capability enables a context type to maintain study and standard information.

    - #### FILES

          public static final Type.Capability FILES

      This capability enables a context (and folder) type to enable folders and files to be created within the context. This capability is always defined with the folder type. But, can be configured by customers when their custom configurable hierarchy is configured.

  - ### Method Detail

    - #### values

          public static Type.Capability[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (Type.Capability c : Type.Capability.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static Type.Capability valueOf​(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null